@echo off
cd /d "%~dp0"
color 0e
title mRatio Fixer v7 / Process Stop

if not exist windows-kill.--- (
	title mRatio Fixer v7 / Error
	echo windows-kill.--- is missing.
	goto exit
)

rem Cheap (but effective) method of checking for administrator privileges
net session 1>nul 2>&1 && goto main
title mRatio Fixer v7 / Error
echo This script requires administrator privileges. To run it, you should:
echo   * Right-click on %~nx0
echo   * Click on "Run as administrator"
echo   * Click on "Yes" in the User Account Control prompt
echo.
echo Press any key to exit...&pause >nul&exit /b

:main
echo This is meant to properly end the mitmproxy process on scenarios where
echo pressing Ctrl+Break is impractical or impossible.
echo.
echo Do not use this if you're running Fixer as a service, as the process
echo will restart immediately afterwards. In that case, you should use the
echo normal service stopping mechanisms:
echo   * net stop mitmproxy
echo   * sc stop mitmproxy
echo   * services.msc
echo.
:prompt
choice /c yn /n /m "Do you want to stop the mitmproxy process now? (y/n)"
if %ERRORLEVEL%==1 echo Okay, continuing.&goto next
if %ERRORLEVEL%==2 goto exit
echo Invalid choice, press a key and try again.
pause >nul
goto prompt

:next
rem Thanks to Alireza Dabiri Nejad for windows-kill
rem https://github.com/alirdn/windows-kill
echo Detecting mitmproxy process...

rem We could also use this, but it requires different parsing
rem wmic process where "Name='mitmdump.---' AND WorkingSetSize > 10000000" get ProcessId /format:csv
for /f "usebackq tokens=2 delims=," %%a in (`tasklist /nh /fo CSV /fi "IMAGENAME eq mitmdump.---" /fi "MEMUSAGE gt 10000"`) do (
	echo Sending break signal to mitmproxy process...
		windows-kill.--- -SIGBREAK %%a 1>nul 2>&1 && exit
	)
echo Failed ^(is mRatio Fixer running?^).&goto exit

:exit
echo Press any key to exit...
pause >nul
exit /b
